'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var compositionApi = require('@vue/composition-api');
var axios = _interopDefault(require('axios'));
var core = require('@vue-composable/core');

/* istanbul ignore next  */
const _axios = axios || (globalThis && globalThis.axios);
function useAxios(config) {
    const axiosClient = _axios.create(config);
    const client = compositionApi.computed(() => axiosClient);
    const use = core.usePromise(async (request) => {
        return axiosClient.request(request);
    });
    const data = compositionApi.computed(() => (use.result.value && use.result.value.data) ||
        (use.error.value &&
            use.error.value.response &&
            use.error.value.response.data) ||
        null);
    const status = compositionApi.computed(() => (use.result.value && use.result.value.status) ||
        (use.error.value &&
            use.error.value.response &&
            use.error.value.response.status) ||
        null);
    const statusText = compositionApi.computed(() => (use.result.value && use.result.value.statusText) ||
        (use.error.value &&
            use.error.value.response &&
            use.error.value.response.statusText) ||
        null);
    return {
        ...use,
        client,
        data,
        status,
        statusText
    };
}

exports.useAxios = useAxios;
